// ======================================================= //
//
//	CHG SLA RECALC
//
//	Calculating.......................................[V]
//
//	# cdtj71@gmail.com
//	# 2015-11-11
//
// ======================================================= //

// 1451674799 
#define ILIMIT 10000000
void calc_init(int start_date) {
	int i, zcount;
	object zobj, zfound;

	set_ilimit(ILIMIT);
	
	send_wait(0, top_object(), "call_attr", "chg", "sync_fetch", "DYNAMIC", format("active = 1 AND z_atev_violate > %d AND status IN ('TEST_IMPL', 'IMPL') AND z_dlit_realiz > 0", start_date), -1, 0);
	zcount = msg[1];
	printf("CHGs found: %d\n\n", zcount);
	if (zcount > 0) {
		zfound = msg[0];
	} else {
		return;
	}
	for (i=0;i<zcount;i++) {
		send_wait(0, zfound, "dob_by_index", "DEFAULT", i, i);
		zobj = msg[0];
		calc(format("chg:%d", zobj.id));
	}
}

void calc(string obj_id) {
	object chg, zfound, zobj, atev_found;
	int msg_i, delta, zcount;
	date correct_date, current_date;
	duration dur;
	
	uuid who;
	send_wait(0,top_object(), "call_attr", "cnt", "current_user_id");
	who=msg[0];
	if (is_null(who)) {
		printf("Define correct user (bop_cmd -u USERID)");
		return;
	}
	
	send_wait(0, top_object(), "call_attr", "chg", "dob_by_persid", 0, obj_id);
	if (msg_error()) {
		printf("Invalid chg persid (or not found) [%s] : \n", obj_id);
		for (msg_i=0;msg_i<msg_length();msg_i++) {
			printf("msg[%d] : %s\n", msg_i, msg[msg_i]);
		}
		return;
	}
	chg = msg[0];
	
	printf("chg [%s] dlit [%d] current sla [%s]\n\n", chg.chg_ref_num, chg.z_dlit_realiz, chg.z_atev_violate);
	current_date = chg.z_atev_violate;
	
	send_wait(0, top_object(), "call_attr", "atev", "sync_fetch", "DYNAMIC", format("obj_id='chg:%s' AND status_flag=2 AND event_tmpl.violate_on_true=1", chg.id), -1, 0);
	for (msg_i=0;msg_i<msg_length();msg_i++) {
		printf("msg[%d] : %s\n", msg_i, msg[msg_i]);
	}
	zcount = msg[1];
	if (zcount > 0) {
		atev_found = msg[0];
		send_wait(0, msg[0], "dob_by_index", "DEFAULT", (int)(zcount-1), (int)(zcount-1));
		for (msg_i=0;msg_i<msg_length();msg_i++) {
			printf("msg[%d] : %s\n", msg_i, msg[msg_i]);
		}
		zobj = msg[0];
		dur = (duration)((int)(chg.z_dlit_realiz * 9 * 3600));
		printf("\n\natev : %s, dur: %s, chg.z_workshift: %s\n\n", zobj.start_time, dur, chg.z_workshift);
		if ( !is_null(chg.z_workshift.sched) && !is_null(zobj.start_time) && !is_null(dur) ) {
			correct_date = workshift_work2abs(chg.z_workshift.sched, zobj.start_time, dur);
			delta = (int)correct_date-(int)current_date;
			printf("Start delta: [%s]\n", delta);
			if (delta < 0) {
				delta *= -1;
			}
			
			if (delta < 300) {
				printf("SLA is valid! [%s]\n", delta);
			} else {
				printf("SLA is invalid!\n");
				printf("Current: %s\nValid: %s\n", current_date, correct_date);
				send_wait(0, top_object(), "call_attr", "api", "insert_object", who, "chgalg", NULL, 0, "type", "SLA_ADJ", "time_spent", (duration)0, "change_id", chg.id, "z_vozvr_date", (int)correct_date, "description", format("Автоматическая корректировка SLA в соответствии с обновлением рабочего расписания на 2016 год.\nСтарый SLA: %s\nНовый SLA:%s", current_date, correct_date));
			}
		}
	}
}



// HERE IS "SLA_ADJ"
chgalg::z_adj_sla(...) {
	object zsla, zatev, zfound;
	int i, zcount;
	duration adjslacalc;
	date adjdate, newdate, nowdate;
	nowdate = now();
	adjdate = z_vozvr_date;
	
	// Fetch z_SLA
	send_wait(0, top_object(), "call_attr", "atev", "sync_fetch", "MLIST_STATIC", format("obj_id='%s' AND status_flag=2 AND z_SLA is not NULL AND group_name='UC'", change_id.persistent_id), -1, 0);
	zcount = msg[1];
	if (zcount == 0) {
		logf(ERROR, "Cant fetch any active SLA for object [%s]\n", change_id.chg_ref_num);
		set_error(1);
		set_return_data(format("Cant fetch any active SLA for object [%s]\n", change_id.chg_ref_num));
		return;
	} else {
		logf(SIGNIFICANT, "Found %d SLAs for [%s]\n", zcount, change_id.chg_ref_num);
	}
	zfound = msg[0];
	send_wait(0, zfound, "dob_by_index", "DEFAULT", 0, 0);
	zsla = msg[0];
	logf(SIGNIFICANT, "zSLA KEY is [%s]\n", zsla.z_SLA);
	
	// Enum
	send_wait(0, top_object(), "call_attr", "atev", "sync_fetch", "MLIST_STATIC", format("obj_id='%s' AND z_SLA='%s' AND status_flag=2", change_id.persistent_id, zsla.z_SLA), -1, 0);
	zcount = msg[1];
	if (zcount == 0) {
		logf(ERROR, "Nothing to extend... [%s]\n", change_id.chg_ref_num);
		set_error(1);
		set_return_data(format("Nothing to extend... [%s]\n", change_id.chg_ref_num));
		return;
	} else {
		logf(SIGNIFICANT, "Found %d atevs for [%s]\n", zcount, change_id.chg_ref_num);
	}
	zfound = msg[0];
	
	for (i=0;i<zcount;i++) {
		send_wait(0, zfound, "dob_by_index", "DEFAULT", i, i);
		zatev = msg[0];
		adjslacalc = workshift_abs2work(change_id.z_workshift.sched, zatev.start_time, adjdate);
		if (sindex(zatev.event_tmpl.sym, '70')>0) {
			adjslacalc = (int)adjslacalc * 70 / 100;
		} else if (sindex(zatev.event_tmpl.sym, '1')>0) {
			adjslacalc = adjslacalc - 3600;
		}
		newdate = workshift_work2abs(change_id.z_workshift.sched, zatev.start_time, adjslacalc);
		logf(SIGNIFICANT, "SLA: %s, NEW DATE: %s\n", zatev.z_SLA_name, (date)newdate);
		if ((int)nowdate > (int)newdate) {
			if (zatev.status_flag == 2) {
				macro::upd_val("atev", format("id=%d", zatev.id), 3, 3, "fire_time", newdate);
			}
		} else {
			macro::upd_val("atev", format("id=%d", zatev.id), 3, 3, "fire_time", newdate, "status_flag", 2);
		}
	}
	send_wait(0, this, "call_attr", "action_desc", "set_val", format("Срок исполнения перенесен с '%s' на '%s'", (date)change_id.z_atev_violate, (date)adjdate), "SURE_SET");
	evt::z_attach_evt("evt:401956", format("chg:%d", change_id), 5);
}

